﻿namespace SimpleVirtualMethods {
	
	class A {
		public void m() {
			Console.WriteLine("A.m()");
		}

		public virtual void f() {
			Console.WriteLine("A.f()");
		}
	}

	class B : A {
		public new void m() {
			Console.WriteLine("B.m()");
		}

		public override void f() {
			Console.WriteLine("B.f()");
		}
	}
	
	class Program {
		static void Main(string[] args) {
			
			A a = new A();
			a.m();
			a = new B();
			a.m();

			Console.WriteLine();

			B b = new B();
			b.m();
			((A) b).m();

			Console.WriteLine();

			a = new A();
			a.f();
			a = new B();
			a.f();

			Console.WriteLine();

			b = new B();
			b.f();
			((A) b).f();

		}
	}
}